• hdu5188 加限制的01背包问题


    http://acm.hdu.edu.cn/showproblem.php?

    pid=5188



    Problem Description
    As one of the most powerful brushes in the world, zhx usually takes part in all kinds of contests.
    One day, zhx takes part in an contest. He found the contest very easy for him.
    There are n problems in the contest. He knows that he can solve the ith problem in ti units of time and he can get vi points.
    As he is too powerful, the administrator is watching him. If he finishes the ith problem before time li, he will be considered to cheat.
    zhx doesn't really want to solve all these boring problems. He only wants to get no less than w points. You are supposed to tell him the minimal time he needs to spend while not being considered to cheat, or he is not able to get enough points. 
    Note that zhx can solve only one problem at the same time. And if he starts, he would keep working on it until it is solved. And then he submits his code in no time.
     

    Input
    Multiply test cases(less than 50). Seek EOF as the end of the file.
    For each test, there are two integers n and w separated by a space. (1n300w109)
    Then come n lines which contain three integers ti,vi,li. (1ti,li105,1vi109)
     

    Output
    For each test case, output a single line indicating the answer. If zhx is able to get enough points, output the minimal time it takes. Otherwise, output a single line saying "zhx is naive!" (Do not output quotation marks).
     

    Sample Input
    1 3 1 4 7 3 6 4 1 8 6 8 10 1 5 2 2 7 10 4 1 10 2 3
     

    Sample Output
    7 8 zhx is naive!
    /**
    hdu5188 有限制条件的01背包问题
    题目大意:有n道题i题用时ti秒,得分vi,在li时间点之前不能做出来,并且一道题不能分开几次做(一旦開始做,必须在ti时间内把它做完)
              问得到w分的最小用时是多少
    解题思路:非常像01背包的基本题,可是有一个li分钟前不能AC的限制,因此第i道题必须在最早第(li-ti)时刻做,我们依照l-t递增排序,然后依照经典解法来做
              即可了
    */
    #include <stdio.h>
    #include <string.h>
    #include <algorithm>
    #include <iostream>
    using namespace std;
    
    struct note
    {
        int t,v,l;
        bool operator <(const note &other)const
        {
            return l-t<other.l-other.t;
        }
    
    }node[35];
    
    int n,m;
    int dp[3000005];
    
    int main()
    {
        while(~scanf("%d%d",&n,&m))
        {
            int sum=0,ans=0,up=0;
            for(int i=0;i<n;i++)
            {
                scanf("%d%d%d",&node[i].t,&node[i].v,&node[i].l);
                sum+=node[i].v;
                ans+=node[i].t;
                up=max(up,node[i].l);
            }
            if(m>sum)
            {
                printf("zhx is naive!
    ");
                continue;
            }
            sort(node,node+n);
            up=max(up,ans);
            memset(dp,0,sizeof(dp));
            for(int i=0;i<n;i++)
            {
                for(int j=up;j>=node[i].l;j--)
                {
                    if(j>=node[i].t)
                    {
                        dp[j]=max(dp[j],dp[j-node[i].t]+node[i].v);
                    }
                }
            }
            int flag=0;
            for(int i=0;i<=up;i++)
            {
                if(dp[i]>=m)
                {
                    printf("%d
    ",i);
                    flag=1;
                    break;
                }
            }
            if(flag==0)
            {
                printf("zhx is naive!
    ");
            }
        }
        return 0;
    }
    


    Problem Description
    As one of the most powerful brushes in the world, zhx usually takes part in all kinds of contests.
    One day, zhx takes part in an contest. He found the contest very easy for him.
    There are n problems in the contest. He knows that he can solve the ith problem in ti units of time and he can get vi points.
    As he is too powerful, the administrator is watching him. If he finishes the ith problem before time li, he will be considered to cheat.
    zhx doesn't really want to solve all these boring problems. He only wants to get no less than w points. You are supposed to tell him the minimal time he needs to spend while not being considered to cheat, or he is not able to get enough points. 
    Note that zhx can solve only one problem at the same time. And if he starts, he would keep working on it until it is solved. And then he submits his code in no time.
     

    Input
    Multiply test cases(less than 50). Seek EOF as the end of the file.
    For each test, there are two integers n and w separated by a space. (1n300w109)
    Then come n lines which contain three integers ti,vi,li. (1ti,li105,1vi109)
     

    Output
    For each test case, output a single line indicating the answer. If zhx is able to get enough points, output the minimal time it takes. Otherwise, output a single line saying "zhx is naive!" (Do not output quotation marks).
     

    Sample Input
    1 3 1 4 7 3 6 4 1 8 6 8 10 1 5 2 2 7 10 4 1 10 2 3
     

    Sample Output
    7 8 zhx is naive!
  • 相关阅读:
    jquery左右滑动效果的实现
    解决IE6不支持position:fixed的bug
    简单的漂浮层
    CSS Image Sprite--网页图片应用处理方式
    浮动层-JS兼容IE6
    js搜索框输入提示(高效-ys8)
    fiddler抓包(移动端APP端)
    python系统介绍
    “多走的弯路”
    接口测试实例(jmeter)
  • 原文地址:https://www.cnblogs.com/yxwkf/p/5194394.html
Copyright © 2020-2023  润新知